import ldap
import string
import tty,sys
import clump.db
from registry import register

class Bind:
    def __init__(self):
        self.name="bind"

    def help(self):
        print ("\nSyntax : BIND <username>\n"+
               "\n"+
               "Binds to the LDAP server using the given username. The\n"+
               "command will prompt for the associated password.\n")

    def execute(self,line):
        if line=="" or len(string.split(line," "))>1:
            print "** SYNTAX ERROR ** Syntax is: BIND <username>"
            return
        uid="cn=%s,ou=Admins,%s" % (line,clump.db.db.base)
        passwd=self.getpass()
        try:
            clump.db.db.db.simple_bind_s(uid,passwd)
        except ldap.INVALID_CREDENTIALS:
            print "** WRONG PASSWORD ** Password invalid"
        print
        return

    def getpass(self,prompt = "Password: "):
        fd = sys.stdin.fileno()
        old = tty.tcgetattr(fd)
        new = tty.tcgetattr(fd)
        new[3] = new[3] & ~tty.ECHO          # lflags
        try:
            tty.tcsetattr(fd, tty.TCSADRAIN, new)
            passwd = raw_input(prompt)
        finally:
            tty.tcsetattr(fd, tty.TCSADRAIN, old)
        return passwd
        
register(Bind())
