import os
import string
import clump.db
from registry import register

class InitStore:
    def __init__(self):
        self.name="init_store"

    def help(self):
        print ("\nSyntax : INIT_STORE <cluster> [CVS]\n"+
               "\n"+
               "Initialises the store area for a given cluster. This\n"+
               "command should only be used when the store area has\n"
               "been cleaned or you wish to add a new cluster to the\n"
               "CVS repository which is done by adding the CVS flag.")
        print

    def execute(self,line):
        fields=string.split(line," ")
        cluster=fields[0]
        try:
            CVSflag=(fields[1]=='CVS')
        except IndexError:
            CVSflag=0
        if line=="" or len(fields)>2:
            print "** SYNTAX ERROR ** "+\
                  "Correct syntax is: STORE_INIT <cluster> [CVS]"
            return
        os.chdir(clump.db.db.cvsbase)
        # Do the initial CVS creation stuff if the flag is set
        if CVSflag:
            try:
                os.makedirs(cluster)
            except:
                print "Failed to create cluster's base store directory"
                return
            os.chdir(cluster)  # Change to the cluster's directory
            val=os.system('cvs import '+
                          '-m "Initial CLuMP data for cluster %s" ' % cluster+
                          '%s CLuMP start 2> /dev/null 1> /dev/null' % cluster)
            if val:
                print "** CVS ERROR ** CVS initial import failed"
                return
            os.chdir(clump.db.db.cvsbase)  # Change back to the top level dir
            # Now delete the directory so we can reimport it from CVS
            os.system("rm -fr %s" % cluster)
        # Checkout the cluster's data from CVS
        val=os.system("cvs checkout -P %s 2> /dev/null 1> /dev/null" % cluster)
        if val:
            print "** CVS ERROR ** CVS checkout failed - "+\
                  "if this is your first time add the 'CVS' flag"
            return
        return

register(InitStore())
