import clump.db
import ldap
from registry import register

class InitDB:
    def __init__(self):
        self.name="initdb"

    def help(self):
        print ("\nSyntax : INITDB\n"+
               "\n"+
               "Creates the initial Clusters folder on the LDAP server\n"+
               "which will be used to hold all the CLuMP clusters. This\n"+
               "command should only ever be executed once when CLuMP is\n"+
               "first run.\n"
               )
        return

    def execute(self,line):
        try:
            clump.db.db.addObject(("ou=Clusters,"+clump.db.db.base,{
                'ou':'Clusters','objectType':'clumpCluster',
                'objectClass':['top','organizationalUnit','clumpFolder']}))
        except ldap.ALREADY_EXISTS:
            print ("** INIT FAILED ** "+
                   "Clump already initialized on this LDAP server")
            return
        except:
            print "** INIT FAILED ** initdb failed"
            return
        print "LDAP server successfully initialized for CLuMP DB"
        return

register(InitDB())
