import string,re
import clump.db
import ldap
from registry import register
from clump.obj.registry import objtype

class Show:
    def __init__(self):
        self.name="show"

    def help(self):
        print ("\nSyntax : SHOW [<name>]\n"+
               "\n"+
               "Shows the attribute values of the specified object. If no\n"+
               "specific name is given it will default to showing the\n"+
               "current object.\n")
        print

    def execute(self,line):
        if line=="":
            dn=clump.db.db.currentDN
        else:
            dn=clump.db.db.string2dn(line)
        if not dn:
            return
        obj=clump.db.db.getObject(dn)
        if "clumpFolder" in obj[1]['objectClass']:
            objtype("clumpFolder").show(obj)
        else:
            type=clump.db.db.getObject(string.join(string.split(
                dn,',')[1:],","))
            try:
                type=type[1]['objectType'][0]
            except KeyError:
                print "** NO FOLDER ** This object is not in a folder!"
                return
            objtype(type).show(obj)
        return

register(Show())
