import socket
import string
import clump.db
from clump.interface import *
from registry import register
from clump.filemaker import makeFile
from clump.obj.registry import objtype
import clump.init

class Update:
    def __init__(self):
        self.name="update"

    def help(self):
        print ("\nSyntax : UPDATE\n"+
               "\n"+
               "Updates all the configuration files for the node. This\n"+
               "command will connect to the server and determine whether\n"+
               "any configuration files have changed. It will then update\n"+
               "those files and ensure that the relevant processes are\n"+
               "restarted.\n")

    def execute(self,line):
        if line!="":
            flist=string.split(line," ")
        else:
            flist=[]
        if clump.db.db.hostcluster=="":
            print "** NO CLUSTER ** No cluster defined in config file"
            return
        attrlist=['objectClass','fileData']
        for field in objtype("configFile").fields:
            attrlist.append(field.ldapname)
        if not objtype("configFile").namefield in attrlist:
            attrlist.append(objtype("configFile").namefield)
        files={}
        # First get all the cluster level configuration files
        fileobjs=getAllInCluster("configFile",subdir="Files",attrlist=attrlist)
        if fileobjs:
            for fileobj in fileobjs:
                makeFile(fileobj,files)
        # Next embark on getting all the netgroup configuration files...
        fileobjs=getAllInNetgroups("configFile",subdir="Files",
                                   attrlist=attrlist)
        if fileobjs:
            for fileobj in fileobjs:
                makeFile(fileobj,files)
        # Finally get all the host level configuration files
        fileobjs=getAllInNode("configFile",subdir="Files",attrlist=attrlist)
        if fileobjs:
            for fileobj in fileobjs:
                makeFile(fileobj,files)
        for key in files.keys():
            if flist!=[] and not key in flist:
                continue
            files[key].update()
        clump.init.update()

register(Update())
