# These import include all packages which the compiled code objects can access
import db
import os
import marshal
import socket
from logfile import log
from interface import *

class ConfigFile:
    def __init__(self,data):
        self.name=data['cn']
        if 'fileName' in data.keys():
            self.filename=data['fileName'][0]
        else:
            self.filename=data['cn'][0]
        if not self.filename[0]=='/':
            self.filename="/"+self.filename
        try:
            self.mode=data['accessMode'][0]
        except KeyError:
            self.mode="644"
        try:
            self.uid=data['uid'][0]
        except KeyError:
            self.uid="root"
        try:
            self.gid=data['gid'][0]
        except KeyError:
            self.gid="root"
        self.data=data['fileData'][0]

    def onChange(self):
        return

    def writeText(self):
        return ""

    def update(self):
        text=self.writeText()
        try:
            oldfile=open(self.filename,"r")
            oldtext=oldfile.read()
            oldfile.close()
        except IOError:
            oldtext=""
        if oldtext!=text:
            file=open("%s" % self.filename,"w")
            file.write(text)
            file.close()
            log.write("Updated file %s" % self.filename)
            self.onChange()
        else:
            print "File %s remains unchanged" % self.filename
        os.system("chmod %s %s" % (self.mode,self.filename))
        os.system("chown %s.%s %s" % (self.uid,self.gid,self.filename))
        return

class PlainFile(ConfigFile):
    def __init__(self,data):
        ConfigFile.__init__(self,data)

    def writeText(self):
        return self.data

class MacroFile(ConfigFile):
    def __init__(self,data):
        ConfigFile.__init__(self,data)

    def writeText(self):
        try:
            return self.data % getMacros()
        except:
            print ("** MACRO ERROR ** File '%s' is not a good macro file or "+
                   "this node has no CLuMP definition") % self.name
            return ""

def makeFile(fileobj,dict):
    dn,attr=fileobj
    if attr['fileType'][0]=='plain':
        newfile=PlainFile(attr)
        dict[newfile.filename]=newfile
        return
    elif attr['fileType'][0]=='macro':
        newfile=MacroFile(attr)
        dict[newfile.filename]=newfile
        return
    elif attr['fileType'][0]!='python':
        print ("** UNKNOWN FILE TYPE ** Unknown file type '%s'" %
               attr['fileType'])
        return
    exec(marshal.loads(attr['fileData'][0]))
##    a=createClass(attr)
##    dict[a.filename]=a
##    return
    makeFileInstance(attr,dict)
    return 

def compileFile(code):
    try:
        codeobj=compile(code,"<string>","exec")
    except:
        print "** COMPILE FAILURE ** Python file fails to compile"
        return ""
    code=marshal.dumps(codeobj)
    return code

