from basegui import *
from delete import confirmDelete
from clump.interface import *
from clump.obj.cluster import Cluster
from gtk import *
from node  import NodeGUI
from mount import MountGUI
from user  import UserGUI
from group import GroupGUI
from netgroup import NetgroupGUI
from init  import InitGUI
from file  import FileGUI

#===========================================================================
# SIGNAL FUNCTIONS: Functions used to handle signals
#
def getSelected(widget_name,objclass,dir,keyfield='cn'):
    widget=BaseGUI.wTree.get_widget(widget_name)
    try:
        name=widget.get_text(widget.selection[0],0)
    except IndexError:
        return None
    objs=getAllInCluster(objclass,dir)
    data=None
    for obj in objs:
        try:
            if obj[1][keyfield][0]==name:
                data=obj
                break
        except KeyError:
            pass
    return data

class ClusterSignals:
    def CLUSTER_destroy(obj,event):
        mainquit()

    def CLUSTER_cancel(obj):
        mainquit()

    def CLUSTER_apply(obj):
        ClusterGUI.instance.update()

    def CLUSTER_commit(obj):
        if ClusterGUI.instance.update():
            mainquit()

    def CLUSTER_bind(obj):
        BaseGUI.wTree.get_widget("BIND_window").show()

    def CLUSTER_userlist_click_column(obj,col):
        widget=BaseGUI.wTree.get_widget("CLUSTER_userlist")
        widget.set_sort_column(col)
        widget.sort()

    def CLUSTER_grouplist_click_column(obj,col):
        widget=BaseGUI.wTree.get_widget("CLUSTER_grouplist")
        widget.set_sort_column(col)
        widget.sort()

    def CLUSTER_newnode(obj):
        NodeGUI.instance.parent=ClusterGUI
        NodeGUI.instance.setupNew("ou=Nodes,"+ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("NODE_window").show()

    def CLUSTER_editnode(obj):
        data=getSelected("CLUSTER_nodelist","clumpNode","Nodes")
        if data:
            NodeGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("NODE_window").show()
        return

    def CLUSTER_delnode(obj):
        confirmDelete(getSelected("CLUSTER_nodelist","clumpNode","Nodes"),
                      ClusterGUI)

    def CLUSTER_newmount(obj):
        MountGUI.instance.parent=ClusterGUI
        MountGUI.instance.setupNew("ou=Fstab,"+ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("MOUNT_window").show()

    def CLUSTER_editmount(obj):
        data=getSelected("CLUSTER_fstablist","clumpMount","Fstab")
        if data:
            MountGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("MOUNT_window").show()
        return

    def CLUSTER_delmount(obj):
        confirmDelete(getSelected("CLUSTER_fstablist","clumpMount","Fstab"),
                      ClusterGUI)

    def CLUSTER_newuser(obj):
        UserGUI.instance.parent=ClusterGUI
        UserGUI.instance.setupNew("ou=Users,"+ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("USER_window").show()

    def CLUSTER_edituser(obj):
        data=getSelected("CLUSTER_userlist","clumpUser","Users","uid")
        if data:
            UserGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("USER_window").show()
        return

    def CLUSTER_deluser(obj):
        confirmDelete(getSelected("CLUSTER_userlist","clumpUser",
                                  "Users","uid"),ClusterGUI)

    def CLUSTER_newgroup(obj):
        GroupGUI.instance.parent=ClusterGUI
        GroupGUI.instance.setupNew("ou=Groups,"+ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("GROUP_window").show()

    def CLUSTER_editgroup(obj):
        data=getSelected("CLUSTER_grouplist","posixGroup","Groups")
        if data:
            GroupGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("GROUP_window").show()
        return

    def CLUSTER_delgroup(obj):
        confirmDelete(getSelected("CLUSTER_grouplist","posixGroup","Groups"),
                      ClusterGUI)

    def CLUSTER_newnetgroup(obj):
        NetgroupGUI.instance.parent=ClusterGUI
        NetgroupGUI.instance.setupNew("ou=Netgroups,"+
                                      ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("NETGROUP_window").show()

    def CLUSTER_editnetgroup(obj):
        data=getSelected("CLUSTER_netgrouplist","clumpNetgroup","Netgroups")
        if data:
            NetgroupGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("NETGROUP_window").show()
        return

    def CLUSTER_delnetgroup(obj):
        confirmDelete(getSelected("CLUSTER_netgrouplist","clumpNetgroup",
                                  "Netgroups"),ClusterGUI)

    def CLUSTER_newinit(obj):
        InitGUI.instance.parent=ClusterGUI
        InitGUI.instance.setupNew("ou=Init,"+ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("INIT_window").show()

    def CLUSTER_editinit(obj):
        data=getSelected("CLUSTER_initlist","clumpInitService","Init")
        if data:
            InitGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("INIT_window").show()
        return

    def CLUSTER_delinit(obj):
        confirmDelete(getSelected("CLUSTER_initlist","clumpInitService",
                                  "Init"),ClusterGUI)

    def CLUSTER_newfile(obj):
        FileGUI.instance.parent=ClusterGUI
        FileGUI.instance.setupNew("ou=Files,"+ClusterGUI.instance.data[0])
        BaseGUI.wTree.get_widget("FILE_window").show()

    def CLUSTER_editfile(obj):
        data=getSelected("CLUSTER_filelist","configFile","Files","fileName")
        if not data:
            data=getSelected("CLUSTER_filelist","configFile","Files")
        if data:
            FileGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("FILE_window").show()
        return

    def CLUSTER_delfile(obj):
        confirmDelete(getSelected("CLUSTER_filelist","configFile","Files"),
                      ClusterGUI)

    def CLUSTER_addmaster(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newmaster_entry").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_masterlist")
        if value and widget.find_row_from_data(["",value])==-1:
            widget.append(["",value])
        widget.sort()
        ClusterGUI.instance.setupMaster()

    def CLUSTER_delmaster(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_masterlist")
        widget.remove(widget.selection[0])
        ClusterGUI.instance.setupMaster()

    def CLUSTER_setmaster(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_masterlist")
        for i in range(0,widget.rows):
            widget.set_text(i,0,"")
        widget.set_pixmap(widget.selection[0],0,Pixmap.yes)

    def CLUSTER_addadmin(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newadmin_entry").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_adminlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()
        ClusterGUI.instance.setupAdmin()

    def CLUSTER_deladmin(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_adminlist")
        widget.remove(widget.selection[0])
        ClusterGUI.instance.setupAdmin()

    def CLUSTER_adddns(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newdns").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_dnslist")
        if value and widget.find_row_from_data(["",value])==-1:
            widget.append(["",value])
        widget.sort()

    def CLUSTER_deldns(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_dnslist")
        widget.remove(widget.selection[0])

    def CLUSTER_setdns(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_dnslist")
        for i in range(0,widget.rows):
            widget.set_text(i,0,"")
        widget.set_pixmap(widget.selection[0],0,Pixmap.yes)

    def CLUSTER_addkdc(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newkdc").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_kdclist")
        if value and widget.find_row_from_data(["",value])==-1:
            widget.append(["",value])
        widget.sort()

    def CLUSTER_delkdc(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_kdclist")
        widget.remove(widget.selection[0])

    def CLUSTER_setkdc(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_kdclist")
        for i in range(0,widget.rows):
            widget.set_text(i,0,"")
        widget.set_pixmap(widget.selection[0],0,Pixmap.yes)

    def CLUSTER_addntp(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newntp").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_ntplist")
        if value and widget.find_row_from_data(["",value])==-1:
            widget.append(["",value])
        widget.sort()

    def CLUSTER_delntp(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_ntplist")
        widget.remove(widget.selection[0])

    def CLUSTER_setntp(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_ntplist")
        for i in range(0,widget.rows):
            widget.set_text(i,0,"")
        widget.set_pixmap(widget.selection[0],0,Pixmap.yes)

    def CLUSTER_addnfs(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newnfs").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_nfslist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()

    def CLUSTER_delnfs(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_nfslist")
        widget.remove(widget.selection[0])

    def CLUSTER_addlogin(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newlogin").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_loginlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()

    def CLUSTER_dellogin(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_loginlist")
        widget.remove(widget.selection[0])

    def CLUSTER_addtrusted(obj):
        value=BaseGUI.wTree.get_widget("CLUSTER_newtrusted").get_text()
        widget=BaseGUI.wTree.get_widget("CLUSTER_trustedlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()

    def CLUSTER_deltrusted(obj):
        widget=BaseGUI.wTree.get_widget("CLUSTER_trustedlist")
        widget.remove(widget.selection[0])


#===========================================================================
# UTILITY FUNCTIONS: Used for filling in tables, combo box lists etc.
#
def makeList(data,attrib,exclude=[]):
    list=[]
    for obj in data:
        try:
            if not obj[1][attrib][0] in list and \
               not obj[1][attrib][0] in exclude:
                list.append(obj[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

#===========================================================================
# GUI Class: Used to fill the GUI window
#
class ClusterGUI(BaseGUI):
    instance=None
    def __init__(self):
        BaseGUI.__init__(self,"CLUSTER_name",Cluster,ClusterSignals,[
            (["CLUSTER_name"],     "cn",              TextWidget,  {} ),
            (["CLUSTER_domain"],   "domainName",      TextWidget,  {} ),
            (["CLUSTER_realm"],    "krbRealm",        TextWidget,  {} )
            ],onNewDisable=[
            "CLUSTER_addnode","CLUSTER_editnode","CLUSTER_delnode",
            "CLUSTER_addnetgroup","CLUSTER_editnetgroup","CLUSTER_delnetgroup",
            "CLUSTER_adduser","CLUSTER_edituser","CLUSTER_deluser",
            "CLUSTER_addgroup","CLUSTER_editgroup","CLUSTER_delgroup",
            "CLUSTER_addinit","CLUSTER_editinit","CLUSTER_delinit",
            "CLUSTER_addxinetd","CLUSTER_editxinetd","CLUSTER_delxinetd",
            "CLUSTER_addmount","CLUSTER_editmount","CLUSTER_delmount"])
        BaseGUI.wTree.get_widget("CLUSTER_userlist").set_column_justification(
            1,JUSTIFY_RIGHT)
        BaseGUI.wTree.get_widget("CLUSTER_masterlist").set_sort_column(1)
        BaseGUI.wTree.get_widget("CLUSTER_dnslist").set_sort_column(1)
        BaseGUI.wTree.get_widget("CLUSTER_kdclist").set_sort_column(1)
        BaseGUI.wTree.get_widget("CLUSTER_ntplist").set_sort_column(1)
        
    # Setup all the administrator widgets
    def setupAdmin(self):
        widget=BaseGUI.wTree.get_widget("CLUSTER_adminlist")
        admins=[]
        for i in range(0,widget.rows):
            admins.append(widget.get_text(i,0))
        BaseGUI.wTree.get_widget("CLUSTER_newadmin").set_popdown_strings(
            makeList(getAllInCluster("clumpUser","Users"),"uid",admins))

    # Setup all the Master node widgets
    def setupMaster(self):
        widget=BaseGUI.wTree.get_widget("CLUSTER_masterlist")
        masters=[]
        for i in range(0,widget.rows):
            masters.append(widget.get_text(i,1))
        BaseGUI.wTree.get_widget("CLUSTER_newmaster").set_popdown_strings(
            makeList(getAllInCluster("clumpNode","Nodes"),"cn",masters))

    def setup(self,data):
        BaseGUI.setup(self,data)
        # Setup initial master node list
        widget=BaseGUI.wTree.get_widget("CLUSTER_masterlist")
        widget.clear()
        try:
            for admin in self.data[1]['masterNode']:
                widget.append(["",admin])
            widget.set_pixmap(0,0,Pixmap.yes)
            widget.sort()
        except KeyError:
            pass
        # Setup initial admin list
        widget=BaseGUI.wTree.get_widget("CLUSTER_adminlist")
        widget.clear()
        try:
            for admin in self.data[1]['sysAdmin']:
                widget.append([admin])
            widget.sort()
        except KeyError:
            pass
        self.setupAdmin()  # Setup popdown string list
        self.setupMaster() # Setup popdown string list
        # Setup initial DNS list
        widget=BaseGUI.wTree.get_widget("CLUSTER_dnslist")
        widget.clear()
        try:
            for srv in self.data[1]['dnsServer']:
                widget.append(["",srv])
            widget.set_pixmap(0,0,Pixmap.yes)
            widget.sort()
        except KeyError:
            pass
        # Setup initial KDC list
        widget=BaseGUI.wTree.get_widget("CLUSTER_kdclist")
        widget.clear()
        try:
            for srv in self.data[1]['kdcServer']:
                widget.append(["",srv])
            widget.set_pixmap(0,0,Pixmap.yes)
            widget.sort()
        except KeyError:
            pass
        # Setup initial NTP list
        widget=BaseGUI.wTree.get_widget("CLUSTER_ntplist")
        widget.clear()
        try:
            for srv in self.data[1]['ntpServer']:
                widget.append(["",srv])
            widget.set_pixmap(0,0,Pixmap.yes)
            widget.sort()
        except KeyError:
            pass
        # Setup initial NFS list
        widget=BaseGUI.wTree.get_widget("CLUSTER_nfslist")
        widget.clear()
        try:
            for srv in self.data[1]['nfsServer']:
                widget.append([srv])
            widget.sort()
        except KeyError:
            pass
        # Setup initial login list
        widget=BaseGUI.wTree.get_widget("CLUSTER_loginlist")
        widget.clear()
        try:
            for srv in self.data[1]['loginServer']:
                widget.append([srv])
            widget.sort()
        except KeyError:
            pass
        # Setup initial trusted list
        widget=BaseGUI.wTree.get_widget("CLUSTER_trustedlist")
        widget.clear()
        try:
            for srv in self.data[1]['trustedExternal']:
                widget.append([srv])
            widget.sort()
        except KeyError:
            pass
        # Fill in the list of Nodes
        nodes=getAllInCluster("clumpNode","Nodes",['cn'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_nodelist")
        widget.clear()
        for node in nodes:
            widget.append(node[1]['cn'])
        widget.sort()
        # Fill in the list of Netgroups
        netgroups=getAllInCluster("clumpNetgroup","Netgroups",['cn'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_netgrouplist")
        widget.clear()
        for netgrp in netgroups:
            widget.append(netgrp[1]['cn'])
        widget.sort()
        # Fill in the list of Users
        users=getAllInCluster("clumpUser","Users",[
            'uid','uidNumber','gn','sn'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_userlist")
        widget.clear()
        for user in users:
            try:
                row=[user[1]['uid'][0],user[1]['uidNumber'][0],"%s %s" % (
                    user[1]['gn'][0],user[1]['sn'][0])]
            except KeyError:
                row=[user[1]['uid'][0],user[1]['uidNumber'][0],""]
            widget.append(row)
        widget.sort()
        # Fill in the list of Groups
        groups=getAllInCluster("posixGroup","Groups",['cn','gidNumber'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_grouplist")
        widget.clear()
        for group in groups:
            widget.append([group[1]['cn'][0],group[1]['gidNumber'][0]])
        widget.sort()
        # Fill in the list of Fstab entries
        entries=getAllInCluster("clumpMount","Fstab",[
            'objectClass','cn','mountDirectory','mountType'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_fstablist")
        widget.clear()
        for entry in entries:
            widget.append([entry[1]['cn'][0],
                           entry[1]['mountDirectory'][0],
                           entry[1]['mountType'][0]
                           ])
        widget.sort()
        # Fill in the list of config files
        entries=getAllInCluster("configFile","Files",[
            'cn','fileName','uid','gid','accessMode','fileType'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_filelist")
        widget.clear()
        for entry in entries:
            try:
                widget.append([entry[1]['fileName'][0],
                               entry[1]['uid'][0],
                               entry[1]['gid'][0],
                               entry[1]['accessMode'][0],
                               entry[1]['fileType'][0]
                               ])
            except KeyError:
                widget.append(["%s" % entry[1]['cn'][0],
                               "--","--","--","--"])
        widget.sort()
        # Fill in the list of Init services
        inits=getAllInCluster("clumpInitService","Init",['cn'])
        widget=BaseGUI.wTree.get_widget("CLUSTER_initlist")
        widget.clear()
        for init in inits:
            widget.append(init[1]['cn'])
        widget.sort()

    def getData(self):
        # Extract the list of masters
        widget=BaseGUI.wTree.get_widget("CLUSTER_masterlist")
        self.data[1]['masterNode']=[]
        for i in range(0,widget.rows):
            try:
                widget.get_text(i,0)
                self.data[1]['masterNode'].append(widget.get_text(i,1))
            except ValueError:
                self.data[1]['masterNode']=[widget.get_text(i,1)]+\
                                            self.data[1]['masterNode']
        # Extract the list of admins
        widget=BaseGUI.wTree.get_widget("CLUSTER_adminlist")
        self.data[1]['sysAdmin']=[]
        for i in range(0,widget.rows):
            self.data[1]['sysAdmin'].append(widget.get_text(i,0))
        # Extract the list of dns servers
        widget=BaseGUI.wTree.get_widget("CLUSTER_dnslist")
        self.data[1]['dnsServer']=[]
        for i in range(0,widget.rows):
            try:
                widget.get_text(i,0)
                self.data[1]['dnsServer'].append(widget.get_text(i,1))
            except ValueError:
                self.data[1]['dnsServer']=[widget.get_text(i,1)]+\
                                            self.data[1]['dnsServer']
        # Extract the list of kdc servers
        widget=BaseGUI.wTree.get_widget("CLUSTER_kdclist")
        self.data[1]['kdcServer']=[]
        for i in range(0,widget.rows):
            try:
                widget.get_text(i,0)
                self.data[1]['kdcServer'].append(widget.get_text(i,1))
            except ValueError:
                self.data[1]['kdcServer']=[widget.get_text(i,1)]+\
                                            self.data[1]['kdcServer']
        # Extract the list of ntp servers
        widget=BaseGUI.wTree.get_widget("CLUSTER_ntplist")
        self.data[1]['ntpServer']=[]
        for i in range(0,widget.rows):
            try:
                widget.get_text(i,0)
                self.data[1]['ntpServer'].append(widget.get_text(i,1))
            except ValueError:
                self.data[1]['ntpServer']=[widget.get_text(i,1)]+\
                                            self.data[1]['ntpServer']
        # Extract the list of nfs servers
        widget=BaseGUI.wTree.get_widget("CLUSTER_nfslist")
        self.data[1]['nfsServer']=[]
        for i in range(0,widget.rows):
            self.data[1]['nfsServer'].append(widget.get_text(i,0))
        # Extract the list of login servers
        widget=BaseGUI.wTree.get_widget("CLUSTER_loginlist")
        self.data[1]['loginServer']=[]
        for i in range(0,widget.rows):
            self.data[1]['loginServer'].append(widget.get_text(i,0))
        # Extract the list of trusted servers
        widget=BaseGUI.wTree.get_widget("CLUSTER_trustedlist")
        self.data[1]['trustedExternal']=[]
        for i in range(0,widget.rows):
            self.data[1]['trustedExternal'].append(widget.get_text(i,0))
        return BaseGUI.getData(self)

ClusterGUI.instance=ClusterGUI()
