from basegui import *
from clump.interface import *
from clump.obj.group import Group
from gtk import *

#===========================================================================
# SIGNAL FUNCTIONS: Functions used to handle signals
#
class GroupSignals:
    def GROUP_destroy(obj,event):
        BaseGUI.wTree.get_widget("GROUP_window").hide()
        return -1

    def GROUP_cancel(obj):
        BaseGUI.wTree.get_widget("GROUP_window").hide()

    def GROUP_apply(obj):
        GroupGUI.instance.update()

    def GROUP_commit(obj):
        if GroupGUI.instance.update():
            BaseGUI.wTree.get_widget("GROUP_window").hide()

    def GROUP_adduser(obj):
        value=BaseGUI.wTree.get_widget("GROUP_newuser").entry.get_text()
        widget=BaseGUI.wTree.get_widget("GROUP_userlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()
        GroupGUI.instance.setupUser()

    def GROUP_deluser(obj):
        widget=BaseGUI.wTree.get_widget("GROUP_userlist")
        widget.remove(widget.selection[0])
        GroupGUI.instance.setupUser()

#===========================================================================
# UTILITY FUNCTIONS: Used for filling in tables, combo box lists etc.
#
def makeList(data,attrib,exclude=[]):
    list=[]
    for obj in data:
        try:
            if not obj[1][attrib][0] in list and \
               not obj[1][attrib][0] in exclude:
                list.append(obj[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

def getGroupList(attrib):
    list=[]
    groups=getAllInCluster("posixGroup")
    for group in groups:
        try:
            if not group[1][attrib][0] in list:
                list.append(group[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

#===========================================================================
# GUI Class: Used to fill the GUI window
#
class GroupGUI(BaseGUI):
    instance=None
    def __init__(self):
        BaseGUI.__init__(self,"GROUP_name",Group,GroupSignals,[
            (["GROUP_name"],      "cn",                TextWidget,   {} ),
            (["GROUP_gid"],       "gidNumber",         TextWidget,   {} ),
            (["GROUP_password"],  "userPassword",      TextWidget,   {} )
            ])
        GroupGUI.instance=self

    # Setup all the administrator widgets
    def setupUser(self):
        widget=BaseGUI.wTree.get_widget("GROUP_userlist")
        users=[]
        for i in range(0,widget.rows):
            users.append(widget.get_text(i,0))
        BaseGUI.wTree.get_widget("GROUP_newuser").set_popdown_strings(
            makeList(getAllInCluster("clumpUser","Users"),"uid",users))

    def setup(self,data):
        BaseGUI.setup(self,data)
        # Setup initial user list
        widget=BaseGUI.wTree.get_widget("GROUP_userlist")
        widget.clear()
        try:
            for user in self.data[1]['memberUid']:
                widget.append([user])
            widget.sort()
        except KeyError:
            pass
        self.setupUser()  # Setup popdown string list

    def getData(self):
        # Extract the list of users
        widget=BaseGUI.wTree.get_widget("GROUP_userlist")
        self.data[1]['memberUid']=[]
        for i in range(0,widget.rows):
            self.data[1]['memberUid'].append(widget.get_text(i,0))
        return BaseGUI.getData(self)

GroupGUI.instance=GroupGUI()
