from basegui import *
from clump.interface import *
from clump.obj.initsvc import InitService
from gtk import *

#===========================================================================
# SIGNAL FUNCTIONS: Functions used to handle signals
#
class InitSignals:
    def INIT_destroy(obj,event):
        BaseGUI.wTree.get_widget("INIT_window").hide()
        return -1

    def INIT_cancel(obj):
        BaseGUI.wTree.get_widget("INIT_window").hide()

    def INIT_apply(obj):
        InitGUI.instance.update()

    def INIT_commit(obj):
        if InitGUI.instance.update():
            BaseGUI.wTree.get_widget("INIT_window").hide()

#===========================================================================
# UTILITY FUNCTIONS: Used for filling in tables, combo box lists etc.
#

#===========================================================================
# GUI Class: Used to fill the GUI window
#
class InitGUI(BaseGUI):
    instance=None
    def __init__(self):
        BaseGUI.__init__(self,"INIT_name",InitService,InitSignals,[
            (["INIT_name"],      "cn",               TextWidget,   {} )
            ])
        InitGUI.instance=self

    def setup(self,data):
        BaseGUI.setup(self,data)
        for level in range(0,7):
            BaseGUI.wTree.get_widget("INIT_level%s" % level).set_active(0)
        try:
            for level in data[1]['turnOnAtLevel']:
                BaseGUI.wTree.get_widget("INIT_level"+level).set_active(1)
        except KeyError:
            pass

    def getData(self):
        self.data[1]['turnOnAtLevel']=[]
        self.data[1]['turnOffAtLevel']=[]
        for level in range(0,7):
            if BaseGUI.wTree.get_widget("INIT_level%s" % level).get_active():
                self.data[1]['turnOnAtLevel'].append("%s" % level)
            else:
                self.data[1]['turnOffAtLevel'].append("%s" % level)
        return BaseGUI.getData(self)

InitGUI.instance=InitGUI()
