from basegui import *
from clump.interface import *
from clump.obj.mount import Mount
from gtk import *

#===========================================================================
# SIGNAL FUNCTIONS: Functions used to handle signals
#
class MountSignals:
    def MOUNT_destroy(obj,event):
        BaseGUI.wTree.get_widget("MOUNT_window").hide()
        return -1

    def MOUNT_cancel(obj):
        BaseGUI.wTree.get_widget("MOUNT_window").hide()

    def MOUNT_apply(obj):
        MountGUI.instance.update()

    def MOUNT_commit(obj):
        if MountGUI.instance.update():
            BaseGUI.wTree.get_widget("MOUNT_window").hide()

    def MOUNT_addopt(obj):
        value=BaseGUI.wTree.get_widget("MOUNT_newopt").get_text()
        widget=BaseGUI.wTree.get_widget("MOUNT_optlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()

    def MOUNT_delopt(obj):
        widget=BaseGUI.wTree.get_widget("MOUNT_optlist")
        widget.remove(widget.selection[0])

#===========================================================================
# UTILITY FUNCTIONS: Used for filling in tables, combo box lists etc.
#
def getMountList(attrib):
    list=[]
    mounts=getAllInCluster("clumpMount")
    for mount in mounts:
        try:
            if not mount[1][attrib][0] in list:
                list.append(mount[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

def getMountTypeList():
    return ['ext2','nfs','xfs','swap','auto','proc','devpts','iso9660']

#===========================================================================
# GUI Class: Used to fill the GUI window
#
class MountGUI(BaseGUI):
    instance=None
    def __init__(self):
        BaseGUI.__init__(self,"MOUNT_point",Mount,MountSignals,[
            (["MOUNT_point"],     "cn",                TextWidget,   {} ),
            (["MOUNT_directory"], "mountDirectory",    TextWidget,   {} ),
            (["MOUNT_type"],      "mountType",         ComboWidget,
             { 'list' : getMountTypeList } ),
            (["MOUNT_passnum"],   "mountPassNumber",   TextWidget,   {} ),
            (["MOUNT_dump"],      "mountDumpFrequency",TextWidget,   {} )
            ])
        MountGUI.instance=self

    def setup(self,data):
        BaseGUI.setup(self,data)
        # Fill in the list of mount options
        widget=BaseGUI.wTree.get_widget("MOUNT_optlist")
        widget.clear()
        try:
            for name in data[1]['mountOption']:
                widget.append([name])
        except KeyError:
            pass
        widget.sort()

    def getData(self):
        # Extract the list of options
        widget=BaseGUI.wTree.get_widget("MOUNT_optlist")
        self.data[1]['mountOption']=[]
        for i in range(0,widget.rows):
            self.data[1]['mountOption'].append(widget.get_text(i,0))
        return BaseGUI.getData(self)

MountGUI.instance=MountGUI()
