from basegui import *
from clump.interface import *
from clump.obj.netgroup import NetGroup
from gtk import *
from clump.gui.init import InitGUI
from clump.gui.file import FileGUI

#===========================================================================
# SIGNAL FUNCTIONS: Functions used to handle signals
#
def getSelected(widget_name,objclass,dir,keyfield='cn'):
    widget=BaseGUI.wTree.get_widget(widget_name)
    try:
        name=widget.get_text(widget.selection[0],0)
    except IndexError:
        return None
    objs=getAllInNetgroup(
        objclass,BaseGUI.wTree.get_widget("NETGROUP_name").get_text(),dir)
    data=None
    for obj in objs:
        if obj[1][keyfield][0]==name:
            data=obj
            break
    return data

class NetgroupSignals:
    def NETGROUP_destroy(obj,event):
        BaseGUI.wTree.get_widget("NETGROUP_window").hide()
        return -1

    def NETGROUP_cancel(obj):
        BaseGUI.wTree.get_widget("NETGROUP_window").hide()

    def NETGROUP_apply(obj):
        NetgroupGUI.instance.update()

    def NETGROUP_commit(obj):
        if NetgroupGUI.instance.update():
            BaseGUI.wTree.get_widget("NETGROUP_window").hide()

    def NETGROUP_addserver(obj):
        value=BaseGUI.wTree.get_widget("NETGROUP_newserver").entry.get_text()
        widget=BaseGUI.wTree.get_widget("NETGROUP_serverlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()
        NetgroupGUI.instance.setupServer()

    def NETGROUP_delserver(obj):
        widget=BaseGUI.wTree.get_widget("NETGROUP_serverlist")
        widget.remove(widget.selection[0])
        NetgroupGUI.instance.setupServer()

    def NETGROUP_addadmin(obj):
        value=BaseGUI.wTree.get_widget("NETGROUP_newadmin").entry.get_text()
        widget=BaseGUI.wTree.get_widget("NETGROUP_adminlist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()
        NetgroupGUI.instance.setupAdmin()

    def NETGROUP_deladmin(obj):
        widget=BaseGUI.wTree.get_widget("NETGROUP_adminlist")
        widget.remove(widget.selection[0])
        NetgroupGUI.instance.setupAdmin()

    def NETGROUP_addnode(obj):
        value=BaseGUI.wTree.get_widget("NETGROUP_newnode").entry.get_text()
        widget=BaseGUI.wTree.get_widget("NETGROUP_nodelist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()
        NetgroupGUI.instance.setupNode()

    def NETGROUP_delnode(obj):
        widget=BaseGUI.wTree.get_widget("NETGROUP_nodelist")
        widget.remove(widget.selection[0])
        NetgroupGUI.instance.setupNode()

    def NETGROUP_addgroup(obj):
        value=BaseGUI.wTree.get_widget("NETGROUP_newgroup").entry.get_text()
        widget=BaseGUI.wTree.get_widget("NETGROUP_grouplist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append([value])
        widget.sort()
        NetgroupGUI.instance.setupGroup()

    def NETGROUP_delgroup(obj):
        widget=BaseGUI.wTree.get_widget("NETGROUP_grouplist")
        widget.remove(widget.selection[0])
        NetgroupGUI.instance.setupGroup()

    def NETGROUP_newinit(obj):
        InitGUI.instance.parent=NetgroupGUI
        InitGUI.instance.setupNew("ou=Init,"+NetgroupGUI.instance.data[0])
        BaseGUI.wTree.get_widget("INIT_window").show()

    def NETGROUP_editinit(obj):
        data=getSelected("NETGROUP_initlist","clumpInitService","Init")
        if data:
            InitGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("INIT_window").show()
        return

    def NETGROUP_delinit(obj):
        confirmDelete(getSelected("NETGROUP_initlist","clumpInitService",
                                  "Init"),NetgroupGUI)

    def NETGROUP_newfile(obj):
        FileGUI.instance.parent=NetgroupGUI
        FileGUI.instance.setupNew("ou=Files,"+NetgroupGUI.instance.data[0])
        BaseGUI.wTree.get_widget("FILE_window").show()

    def NETGROUP_editfile(obj):
        data=getSelected("NETGROUP_filelist","configFile","Files","fileName")
        if not data:
            data=getSelected("NETGROUP_filelist","configFile","Files")
        if data:
            FileGUI.instance.setup(data)
            BaseGUI.wTree.get_widget("FILE_window").show()
        return

    def NETGROUP_delfile(obj):
        confirmDelete(getSelected("NETGROUP_filelist","configFile","Files"),
                      NetgroupGUI)

#===========================================================================
# UTILITY FUNCTIONS: Used for filling in tables, combo box lists etc.
#
def makeList(data,attrib,exclude=[]):
    list=[]
    for obj in data:
        try:
            if not obj[1][attrib][0] in list and \
               not obj[1][attrib][0] in exclude:
                list.append(obj[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

def getNetgroupList(attrib):
    list=[]
    netgroups=getAllInCluster("clumpNetgroup")
    for netgroup in netgroups:
        try:
            if not netgroup[1][attrib][0] in list:
                list.append(netgroup[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

#===========================================================================
# GUI Class: Used to fill the GUI window
#
class NetgroupGUI(BaseGUI):
    instance=None
    def __init__(self):
        BaseGUI.__init__(self,"NETGROUP_name",NetGroup,NetgroupSignals,[
            (["NETGROUP_name"],      "cn",                TextWidget,   {} )
            ],onNewDisable=[
            "NETGROUP_newinit","NETGROUP_editinit","NETGROUP_delinit",
            "NETGROUP_newfile","NETGROUP_editfile","NETGROUP_delfile"
            ])
        NetgroupGUI.instance=self

    # Setup all the administrator widgets
    def setupAdmin(self):
        widget=BaseGUI.wTree.get_widget("NETGROUP_adminlist")
        admins=[]
        for i in range(0,widget.rows):
            admins.append(widget.get_text(i,0))
        BaseGUI.wTree.get_widget("NETGROUP_newadmin").set_popdown_strings(
            makeList(getAllInCluster("clumpUser","Users"),"uid",admins))

    # Setup all the Server node widgets
    def setupServer(self):
        widget=BaseGUI.wTree.get_widget("NETGROUP_serverlist")
        servers=[]
        for i in range(0,widget.rows):
            servers.append(widget.get_text(i,0))
        BaseGUI.wTree.get_widget("NETGROUP_newserver").set_popdown_strings(
            makeList(getAllInCluster("clumpNode","Nodes"),"cn",servers))

    # Setup all the node widgets
    def setupNode(self):
        widget=BaseGUI.wTree.get_widget("NETGROUP_nodelist")
        nodes=[]
        for i in range(0,widget.rows):
            nodes.append(widget.get_text(i,0))
        BaseGUI.wTree.get_widget("NETGROUP_newnode").set_popdown_strings(
            makeList(getAllInCluster("clumpNode","Nodes"),"cn",nodes))

    # Setup all the node widgets
    def setupGroup(self):
        widget=BaseGUI.wTree.get_widget("NETGROUP_grouplist")
        try:
            groups=self.data[1]['cn']
        except KeyError:
            groups=[]
        for i in range(0,widget.rows):
            groups.append(widget.get_text(i,0))
        BaseGUI.wTree.get_widget("NETGROUP_newgroup").set_popdown_strings(
            makeList(getAllInCluster("clumpNetgroup","Netgroups"),"cn",groups))

    def setup(self,data):
        BaseGUI.setup(self,data)
        # Setup initial admin list
        widget=BaseGUI.wTree.get_widget("NETGROUP_adminlist")
        widget.clear()
        try:
            for admin in self.data[1]['sysAdmin']:
                widget.append([admin])
            widget.sort()
        except KeyError:
            pass
        self.setupAdmin()  # Setup popdown string list
        # Setup initial server list
        widget=BaseGUI.wTree.get_widget("NETGROUP_serverlist")
        widget.clear()
        try:
            for server in self.data[1]['masterNode']:
                widget.append([server])
            widget.sort()
        except KeyError:
            pass
        self.setupServer()  # Setup popdown string list
        # Setup initial node list
        widget=BaseGUI.wTree.get_widget("NETGROUP_nodelist")
        widget.clear()
        try:
            for node in self.data[1]['memberNode']:
                widget.append([node])
            widget.sort()
        except KeyError:
            pass
        self.setupNode()  # Setup popdown string list
        # Setup initial group list
        widget=BaseGUI.wTree.get_widget("NETGROUP_grouplist")
        widget.clear()
        try:
            for group in self.data[1]['memberNisNetgroup']:
                widget.append([group])
            widget.sort()
        except KeyError:
            pass
        self.setupGroup()  # Setup popdown string list
        # Setup init service list
        try:
            entries=getAllInNetgroup("clumpInitService",data[1]['cn'][0],
                                     "Init",['cn'])
        except KeyError:
            entries=[]
        widget=BaseGUI.wTree.get_widget("NETGROUP_initlist")
        widget.clear()
        for entry in entries:
            widget.append([entry[1]['cn'][0]])
        widget.sort()
        # Fill in the list of config files
        try:
            entries=getAllInNetgroup("configFile",data[1]['cn'][0],"Files",[
                'cn','fileName','uid','gid','accessMode','fileType'])
        except KeyError:
            entries=[]
        widget=BaseGUI.wTree.get_widget("NETGROUP_filelist")
        widget.clear()
        for entry in entries:
            try:
                widget.append([entry[1]['fileName'][0],
                               entry[1]['uid'][0],
                               entry[1]['gid'][0],
                               entry[1]['accessMode'][0],
                               entry[1]['fileType'][0]
                               ])
            except KeyError:
                widget.append(["%s" % entry[1]['cn'][0],
                               "--","--","--","--"])
        widget.sort()


    def getData(self):
        # Extract the list of servers
        widget=BaseGUI.wTree.get_widget("NETGROUP_serverlist")
        self.data[1]['masterNode']=[]
        for i in range(0,widget.rows):
            self.data[1]['masterNode'].append(widget.get_text(i,0))
        # Extract the list of admins
        widget=BaseGUI.wTree.get_widget("NETGROUP_adminlist")
        self.data[1]['sysAdmin']=[]
        for i in range(0,widget.rows):
            self.data[1]['sysAdmin'].append(widget.get_text(i,0))
        # Extract the list of nodes
        widget=BaseGUI.wTree.get_widget("NETGROUP_nodelist")
        self.data[1]['memberNode']=[]
        for i in range(0,widget.rows):
            self.data[1]['memberNode'].append(widget.get_text(i,0))
        # Extract the list of netgroups
        widget=BaseGUI.wTree.get_widget("NETGROUP_grouplist")
        self.data[1]['memberNisNetgroup']=[]
        for i in range(0,widget.rows):
            self.data[1]['memberNisNetgroup'].append(widget.get_text(i,0))
        return BaseGUI.getData(self)

NetgroupGUI.instance=NetgroupGUI()
