from basegui import *
from clump.interface import *
from clump.obj.nic import NIC
from gtk import *

#===========================================================================
# SIGNAL FUNCTIONS: Functions used to handle signals
#
class NICSignals:
    def NIC_destroy(obj,event):
        BaseGUI.wTree.get_widget("NIC_window").hide()
        return -1

    def NIC_cancel(obj):
        BaseGUI.wTree.get_widget("NIC_window").hide()

    def NIC_apply(obj):
        NICGUI.instance.update()

    def NIC_commit(obj):
        if NICGUI.instance.update():
            BaseGUI.wTree.get_widget("NIC_window").hide()

    def NIC_addname(obj):
        value=BaseGUI.wTree.get_widget("NIC_newname").get_text()
        widget=BaseGUI.wTree.get_widget("NIC_namelist")
        if value and widget.find_row_from_data([value])==-1:
            widget.append(["",value])
        widget.sort()

    def NIC_delname(obj):
        widget=BaseGUI.wTree.get_widget("NIC_namelist")
        widget.remove(widget.selection[0])

    def NIC_setprimary(obj):
        widget=BaseGUI.wTree.get_widget("NIC_namelist")
        for i in range(0,widget.rows):
            widget.set_text(i,0,"")
        widget.set_pixmap(widget.selection[0],0,NICGUI.yes1,NICGUI.yes2)

#===========================================================================
# UTILITY FUNCTIONS: Used for filling in tables, combo box lists etc.
#
def getNICList(attrib):
    list=[]
    nics=getAllInCluster("clumpNIC","Nodes",['objectClass',attrib])
    for nic in nics:
        try:
            if not nic[1][attrib][0] in list:
                list.append(nic[1][attrib][0])
        except KeyError:
            continue
    list.sort()
    return list

def getNICDriverList():
    return getNICList('driverModule')

#===========================================================================
# GUI Class: Used to fill the GUI window
#
class NICGUI(BaseGUI):
    instance=None
    yes1,yes2=create_pixmap_from_xpm(
        BaseGUI.wTree.get_widget("NIC_window"),GdkColor(255,255,255),
        "/usr/share/pixmaps/yes.xpm")
    def __init__(self):
        BaseGUI.__init__(self,"NIC_device",NIC,NICSignals,[
            (["NIC_device"],    "dev",               TextWidget,   {} ),
            (["NIC_ipaddress"], "ipHostNumber",      TextWidget,   {} ),
            (["NIC_netmask"],   "ipNetmaskNumber",   TextWidget,   {} ),
            (["NIC_broadcast"], "ipBroadcastNumber", TextWidget,   {} ),
            (["NIC_network"],   "ipNetworkNumber",   TextWidget,   {} ),
            (["NIC_hardware"],  "macAddress",        TextWidget,   {} ),
            (["NIC_onboot"],    "onBoot",            ToggleWidget, {} ),
            (["NIC_driver"],    "driverModule",      ComboWidget,
             { 'list' : getNICDriverList } )
            ])
        BaseGUI.wTree.get_widget("NIC_namelist").set_sort_column(1)
        NICGUI.instance=self

    def setup(self,data):
        BaseGUI.setup(self,data)
        # Fill in the list of IP names
        widget=BaseGUI.wTree.get_widget("NIC_namelist")
        widget.clear()
        try:
            for name in data[1]['cn']:
                widget.append(["",name])
            if data[1]['cn']:
                widget.set_pixmap(0,0,NICGUI.yes1,NICGUI.yes2)
            widget.sort()
        except KeyError:
            pass
        return

    def getData(self):
        # Extract the list of options
        widget=BaseGUI.wTree.get_widget("NIC_namelist")
        self.data[1]['cn']=[]
        for i in range(0,widget.rows):
            try:
                widget.get_text(i,0)
                self.data[1]['cn'].append(widget.get_text(i,1))
            except ValueError:
                self.data[1]['cn']=[widget.get_text(i,1)]+self.data[1]['cn']
        return BaseGUI.getData(self)

NICGUI.instance=NICGUI()
