import clump.db
import re
import ldap
import os
from logfile import log
from interface import *

def updateService(data):
    name=data['cn'][0]
    try:
        onlevels=data['turnOnAtLevel']
    except KeyError:
        onlevels=[]
    try:
        offlevels=data['turnOffAtLevel']
    except KeyError:
        offlevels=[]
    pipe=os.popen("/sbin/chkconfig --list %s" % name,"r")
    text=pipe.read()
    pipe.close()
    change=0
    levels=["off","off","off","off","off","off","off"]
    for state in re.compile("([0-9]):(on|off)").findall(text):
        levels[eval(state[0])]=state[1]
    for level in onlevels:
        if levels[eval(level)]!='on':
            change=1
            levels[eval(level)]='on'
    for level in offlevels:
        if levels[eval(level)]!='off':
            change=1
            levels[eval(level)]='off'
    if change==0:
        return
    os.system("/sbin/chkconfig --level %s %s on" % (
        string.join(onlevels,""),name))
    os.system("/sbin/chkconfig --level %s %s off" % (
        string.join(offlevels,""),name))
    log.write("Updated service %s on:%s off:%s" % (
        name,string.join(onlevels,""),
        string.join(offlevels,"")))
    return

def update():
    services={}
    svcs=clump.db.db.getFolder("ou=Init,cn=%s,ou=Clusters,%s" % (
        clump.db.db.hostcluster,clump.db.db.base))
    for svc in svcs:
        services[svc[1]['cn'][0]]=svc[1]
    svcs=getAllInNetgroups("clumpInitService")
    for svc in svcs:
        services[svc[1]['cn'][0]]=svc[1]
    svcs=getAllInNode("clumpInitService")
    for svc in svcs:
        services[svc[1]['cn'][0]]=svc[1]
    for key in services.keys():
        updateService(services[key])

