# Implements a log file
import pwd
import os
import sys
import time
import socket
import string

class LogFile:
    def __init__(self):
        self.file=None
        self.enabled=1
        self._echo=0

    def echo(self,state):
        self._echo=state

    def disable(self):
        self.enabled=0

    def enable(self):
        self.enabled=1

    def open(self,name):
        try:
            self.file=open(name,'a',0)
        except IOError,msg:
            print "Clump: Failed to open log file '%s':\nError %d, %s" \
                  % (name,msg[0],msg[1])
            sys.exit()
        
    def write(self,msg):
        if not self.enabled:
            return
        if self._echo:
            print msg
        text=(time.strftime("%b %d %H:%M:%S ",time.localtime(time.time()))+
              string.split(socket.gethostname(),".")[0]+" "+
              pwd.getpwuid(os.geteuid())[0]+" clump: "+msg)
        if self.file:
            self.file.write(text+"\n")
        else:
            print text

    def close(self):
        self.file.close()
        self.file=None

log=LogFile()
