import clump.db
import re
import string
from migrator import Migrator
from registry import register
from clump.interface import *

class Fstab(Migrator):
    def __init__(self):
        Migrator.__init__(self)
        self.name="fstab"

    def getObjects(self):
        fstabdn="ou=Fstab,cn=%s,ou=Nodes,cn=%s,ou=Clusters,%s" % (
            self.host,clump.db.db.hostcluster,clump.db.db.base)
        objs=[]
        try:
            file=open('/etc/fstab','r')
            lines=file.readlines()
            file.close()
        except IOError,msg:
            print "** IO ERROR ** Failed to read /etc/fstab: " % msg
            return
        for line in lines:
            line=string.strip(line)
            line=re.compile("\s+").sub(" ",line)
            fields=string.split(line," ")
            data={}
            data['objectClass']=['clumpMount']
            data['cn']=[fields[1]]
            data['mountDirectory']=[fields[0]]
            data['mountType']=[fields[2]]
            data['mountOption']=string.split(fields[3],",")
            data['mountDumpFrequency']=[fields[4]]
            data['mountPassNumber']=[fields[5]]
            objs.append(("cn=%s,%s" % (data['cn'][0],fstabdn),data))
        dupobjs={}
        for line in getAllInCluster("clumpMount",subdir="Fstab"):
            for i in range(0,len(objs)):
                match=1
                for key in objs[i][1].keys():
                    if line[1][key][0]!=objs[i][1][key][0]:
                        match=0
                        break
                if match:
                    dupobjs[i]=1
        for line in getAllInNetgroups("clumpMount",subdir="Fstab"):
            for i in range(0,len(objs)):
                match=1
                for key in objs[i][1].keys():
                    if line[1][key][0]!=objs[i][1][key][0]:
                        match=0
                        break
                if match:
                    dupobjs[i]=1
        dupobjs=dupobjs.keys()
        dupobjs.sort()
        dupobjs.reverse()
        for i in dupobjs:
            del objs[i]
        return objs

register(Fstab())
