import db
import string
from migrator import Migrator
from registry import register

class LocalUsers(Migrator):
    def __init__(self):
        Migrator.__init__(self)
        self.name="users"

    def getObjects(self):
        userdn="ou=Users,cn=%s,ou=Nodes,cn=%s,ou=Clusters,%s" % (
            self.host,db.db.hostcluster,db.db.base)
        try:
            file=open('/etc/passwd','r')
            lines=file.readlines()
            file.close()
        except IOError,msg:
            print "** IO ERROR ** Failed to read /etc/passwd: %s" % msg
            return
        store={}
        for line in lines:
            line=string.strip(line)
            fields=string.split(line,":")
            data={}
            data['cn']=[fields[0]]
            data['uid']=[fields[0]]
            data['uidNumber']=[fields[2]]
            data['gidNumber']=[fields[3]]
            if fields[4]:
                data['cn'].append(fields[4])
            if fields[5]:
                data['homeDirectory']=[fields[5]]
            if fields[6]:
                data['loginShell']=[fields[6]]
            data['objectclass']=['clumpUser','account',
                                 'posixAccount','shadowAccount']
            data['homeVolume']=['localhost:/dev/null']
            store[fields[0]]=data
        try:
            file=open('/etc/shadow','r')
            lines=file.readlines()
            file.close()
        except IOError,msg:
            print "** IO ERROR ** Failed to read /etc/shadow: %s" % msg
            return
        for line in lines:
            line=string.strip(line)
            fields=string.split(line,":")
            try:
                store[fields[0]]['userPassword']=["{crypt}%s" % fields[1]]
                store[fields[0]]['shadowLastChange']=[fields[2]]
                store[fields[0]]['shadowMax']=[fields[4]]
                store[fields[0]]['shadowWarning']=[fields[5]]
            except KeyError:
                print "** FATAL ERROR ** User %s in /etc/shadow" % fields[0]+\
                      " not listed in /etc/passwd!"
        objs=[]
        for key in store.keys():
            objs.append(("uid=%s,%s" % (key,userdn),store[key]))
        return objs

register(LocalUsers())
