import string,re
import ldap
from registry import register
from baseobj import BaseObject,Field

class AutoMap(BaseObject):
    def __init__(self):
        self.fields=[
            Field('mountOption','options',"Mount options"),
            Field('mountDirectory','directory',"Mount directory")
            ]
        self.objclass=['automountMap','automount','clumpMount']
        self.subdirs=[("Dirs","automount")]
        BaseObject.__init__(self,"automap","automountMap","cn")

    def onSet(self,dn,data):
        if data['cn'][0][0]!='/':
            data['cn']=["/%s" % data['cn'][0]]
            dn="cn=/%s" % dn[3:]
        if not data.has_key('ou'):
            data['ou']=data['cn']
        if not data.has_key('mountDirectory'):
            data['mountDirectory']=["ldap:ou=Dirs,%s" % dn]
        text=" "
        if data.has_key("mountOption"):
            if not type(data['mountOption'])==type([]):
                data['mountOption']=[data['mountOption']]
            for opt in data['mountOption']:
                text=text+"%s," % opt
        text=text[:-1]
        data['automountInformation']="%s %s" % (
            data['mountDirectory'][0],text)
        return

register(AutoMap())
