import string
import os
from registry import register
from baseobj import BaseObject,Field

class Cluster(BaseObject):
    def __init__(self):
        self.fields=[
            Field('domainName','domain',"DNS domain name",create=1),
            Field('masterNode','master',"Cluster's master server",create=1),
            Field('dnsServer','dns',"DNS name servers"),
            Field('ntpServer','ntp',"NTP time servers"),
            Field('krbRealm','realm',"Kerberos V realm name"),
            Field('kdcServer','kdc',"KDC kerberos servers"),
            Field('sysAdmin','sysadmin',"System Administrators"),
            Field('nfsServer','nfs',"External NFS servers"),
            Field('loginServer','login',"External login servers"),
            Field('trustedExternal','ext',"Trusted external nodes")
            ]
        self.objclass=['clumpCluster']
        self.subdirs=[
            ("Nodes",     "clumpNode"          ),
            ("Netgroups", "clumpNetgroup"      ),
            ("Files",     "configFile"         ),
            ("Users",     "clumpUser"          ),
            ("Groups",    "posixGroup"         ),
            ("AutoFS",    "automountMap"       ),
            ("Init",      "clumpInitService"   ),
            ("Xinetd",    "clumpXinetdService" ),
            ("Fstab",     "clumpMount"         )
            ]
        BaseObject.__init__(self,"cluster","clumpCluster","cn")

    def onSet(self,dn,data):
        if not data.has_key('domainName'):
            pipe=os.popen("/bin/dnsdomainname","r")
            data['domainName']=pipe.read()
            pipe.close()
            data['domainName']=string.strip(data['domainName'])
            if data['domainName']=="":
                data['domainName']="localdomain"
        
register(Cluster())
