import string,re
from registry import register
from baseobj import BaseObject,Field
import clump.filemaker

class File(BaseObject):
    def __init__(self):
        self.fields=[
            Field('fileType','type',"Type of file",must=1),
            Field('loadFile','load',"Load this file as the source code",
                  show=0),
            Field('uid','owner',"Owner of this file"),
            Field('gid','group',"Group of this file"),
            Field('accessMode','mode',"Access flags for the file"),
            Field('fileName','name',"File's name")
            ]
        self.objclass=['configFile']
        self.subdirs=[]
        BaseObject.__init__(self,"file","configFile","cn")

    def onSet(self,dn,data):
        if not data.has_key('fileType'):
            data['fileType']="plain"
        if data.has_key('loadFile'):
            try:
                file=open(data['loadFile'][0],'r')
            except:
                print "** FILE IO ERROR ** Unable to open data file"
                del data['loadFile']
                return
            data['sourceCode']=file.read()
            file.close()
            del data['loadFile']
            if data['fileType'][0]=='python':
                data['fileData']=clump.filemaker.compileFile(
                    data['sourceCode'])
            else:
                data['fileData']=data['sourceCode']
        return
        
register(File())
