import re
from registry import registry

defaults={}

def readDefaults(data):
    for sect in data.sections():
        dict={}
        if sect=="clump":
            continue
        for opt in data.options(sect):
            if opt=="__name__":
                continue
            dict[opt]=[]
            for tmpval in re.compile(
                "((\"[^\"]*\")|(\'[^\']*\')|([^,]+))\s*,*\s*"
                ).findall(data.get(sect,opt)):
                tval=tmpval[0]
                tval=re.sub("\"([^\"]*)\"","\g<1>",tval)
                tval=re.sub("\'([^\']*)\'","\g<1>",tval)
                dict[opt].append(tval)
            if dict[opt]==[]:
                del dict[opt]
        defaults[sect]=dict
    for key in registry().keys():
        registry()[key].parseDefaults()
    return

def getDefaults(key):
    if defaults.has_key(key):
        return defaults[key]
    else:
        return {}

