import string,re
import ldap
from registry import register
from baseobj import BaseObject,Field

class Mount(BaseObject):
    def __init__(self):
        self.fields=[
            Field('mountOption','option',"Mount option"),
            Field('mountDirectory','directory',"Directory to mount",create=1),
            Field('mountType','type',"Mount type",create=1),
            Field('mountPassNumber','pass',"Pass number for fsck"),
            Field('mountDumpFrequency','dump',"Dump frequency of mount")
            ]
        self.objclass=['clumpMount']
        self.subdirs=[]
        BaseObject.__init__(self,"mount","clumpMount","cn")

    def onSet(self,dn,data):
        text=" -"
        if data.has_key("mountOption"):
            if not type(data['mountOption'])==type([]):
                data['mountOption']=[data['mountOption']]
        else:
            data['mountOption']=['defaults']
        if not data.has_key("mountPassNumber"):
            data['mountPassNumber']=['0']
        if not data.has_key("mountDumpFrequency"):
            data['mountDumpFrequency']=['0']
        return

register(Mount())
