import string,re
import ldap
from registry import register
from baseobj import BaseObject,Field

class NetGroup(BaseObject):
    def __init__(self):
        self.fields=[
            Field('memberNode','node',"Member node"),
            Field('memberNisNetgroup','group',"Member netgroup"),
            Field('sysAdmin','sysadmin',"System administrators"),
            Field('masterNode','server',"Server for this netgroup")
            ]
        self.objclass=['nisNetgroup','clumpNetgroup']
        self.subdirs=[
            ('Files',  'configFile'         ),
            ('Init',   'clumpInitService'   ),
            ('Xinetd', 'clumpXinetdService' ),
            ('Fstab',  'clumpMount'         )
            ]
        BaseObject.__init__(self,"netgroup","clumpNetgroup","cn")

    def onSet(self,dn,data):
        if data.has_key("memberNode"):
            data['nisNetgroupTriple']=[]
            for node in data["memberNode"]:
                data['nisNetgroupTriple'].append("(%s,,)" % node)
        # if there are no member nodes then delete the netgroup triples
        elif data.has_key("nisNetgroupTriple"):
            data['nisNetgroupTriple']=[]
        return

register(NetGroup())
