import string,re
import clump.utils
from registry import register
from baseobj import BaseObject,Field

class NIC(BaseObject):
    def __init__(self):
        self.fields=[
            Field('ipHostNumber','ip',"IP address of NIC",create=1),
            Field('ipBroadcastNumber','broadcast',"Broadcast address"),
            Field('ipNetworkNumber','network',"Network address"),
            Field('ipNetmaskNumber','netmask',"Netmask",create=1),
            Field('macAddress','hwaddr',"Hardware ethernet address"),
            Field('onBoot','boot',"Start this device on boot?"),
            Field('driverModule','driver',"Kernel driver module",create=1),
            Field('cn','name',"Name or alias for this device",create=1)
            ]
        self.objclass=['clumpNIC','ipHost','device']
        self.subdirs=[]
        BaseObject.__init__(self,"NIC","clumpNIC","dev")

    def onSet(self,dn,data):
        if not data.has_key('onBoot'):
            data['onBoot']=['1']
        if not data.has_key('macAddress'):
            data['macAddress']='00:00:00:00:00:00'
        ip=clump.utils.string2ip(data['ipHostNumber'])
        nm=clump.utils.string2ip(data['ipNetmaskNumber'])
        if not data.has_key('ipBroadcastNumber'):
            data['ipBroadcastNumber']=clump.utils.ip2string((~nm)|ip)
        if not data.has_key('ipNetworkNumber'):
            data['ipNetworkNumber']=clump.utils.ip2string(nm&ip)
        return

register(NIC())
