import string,re
import ldap
from registry import register
from baseobj import BaseObject,Field

class User(BaseObject):
    def __init__(self):
        self.fields=[
            Field('cn','name',"Username",must=1),
            Field('gn','cname',"Christian name"),
            Field('sn','surname',"Surname"),
            Field('uidNumber','uid',"Account number",create=1),
            Field('gidNumber','gid',"Primary group ID",create=1),
            Field('homeVolume','volume',"Home directory volume"),
            Field('homeDirectory','home',"Home directory",must=1),
            Field('userPassword','password','Account password'),
            Field('loginShell','shell','Login shell'),
            Field('ou','institute',"User's home institute"),
            Field('mail','email',"User's email address"),
            Field('jpegPhoto','photo',"JPEG photo of the user"),
            Field('telephoneNumber','phone',"Telephone number")
            ]
        self.objclass=['clumpUser','account','posixAccount','automount']
        self.subdirs=[]
        BaseObject.__init__(self,"user","clumpUser","uid")

    def onSet(self,dn,data):
        if not data.has_key('cn'):
            data['cn']=data['uid']
        elif not data['uid'][0] in data['cn']:
            data['cn']=data['cn']+data['uid']
        if not data.has_key('homeVolume'):
            data['homeVolume']=["localhost:/home"]
        if not data.has_key('homeDirectory'):
            data['homeDirectory']="/home/%s" % data['uid'][0]
        if not data.has_key('loginShell'):
            data['loginShell']="/bin/tcsh"
        if not data.has_key('userPassword'):
            data['userPassword']="{KERBEROS}%s" % data['uid'][0]
        if string.find(data['homeVolume'][0],"%s")!=-1:
            dir=data['homeVolume'][0] % data['uid'][0]
        else:
            dir="%s/%s" % (data['homeVolume'][0],data['uid'][0])
        data['automountInformation']="-rw %s" % dir
        return

register(User())
