import string,re
from registry import register
from baseobj import BaseObject,Field

class XinetdService(BaseObject):
    def __init__(self):
        self.fields=[
            Field('serviceName','service',"Name of the service"),
            Field('serviceID','id',"ID of the service"),
            Field('serviceType','type',"Type of the service"),
            Field('serviceFlag','flag',"Service flag"),
            Field('disableService','disable',"Disable the service"),
            Field('socketType','socket',"Type of socket for this service",
                  create=1),
            Field('ipServiceProtocol','protocol',"Service protocol"),
            Field('serviceWait','wait',"Wait for server to complete",create=1),
            Field('uid','user',"User to execute the server as",create=1),
            Field('gid','group',"Group to execute the server as"),
            Field('maxServerInstances','instances',
                  "Maximum number of server instances to allow"),
            Field('niceValue','nice',"Nice value to run the server with"),
            Field('serverExecutable','server',"Server executable",create=1),
            Field('serverArgs','arguments',"Arguments for server executable"),
            Field('accessOnlyFrom','only_from',
                  "Only allow access from these addresses"),
            Field('denyAccessFrom','no_access',
                  "Deny access from these addresses"),
            Field('accessTime','times',"Only allow access at these times"),
            Field('serviceLogType','log_type',"Service log output type"),
            Field('logOnSuccess','log_on_success',
                  "Determine what to log on a successful server execution"),
            Field('logOnFailure','log_on_failure',
                  "Determine what to log on a failed server execution"),
            Field('oncRpcVersion','rpc_version',"RPC program version"),
            Field('oncRpcNumber','rpc_number',
                  "RPC number for unlisted service"),
            Field('environmentVariable','env',
                  "Environment variable to set for server"),
            Field('passVariable','passenv',
                  "Environment variable to pass to server"),
            Field('ipServicePort','port',"IP port number of service"),
            Field('redirectServiceTo','redirect',
                  "Redirect service to this host and port number"),
            Field('bindServiceTo','bind',
                  "Bind service only to this IP address"),
            Field('serviceBanner','banner',
                  "File to dump to screen when connection is established"),
            Field('successBanner','banner_success',
                  "File to dump to screen when connection is successful"),
            Field('failBanner','banner_fail',
                  "File to dump to screen when connection fails"),
            Field('maxInstancesPerSource','per_source',
                  "Max servers per incoming IP address"),
            Field('maxConnectRate','cps',
                  "Maximum connections per second to this server"),
            Field('maxLoad','max_load',
                  "Load above which this service will be stopped"),
            Field('supplementalGroups','groups',
                  "Access all groups to which the server's uid belongs"),
            Field('addressSpaceLimit','rlimit_as',
                  "Address space resource limit"),
            Field('cpuTimeLimit','rlimit_cpu',"CPU time limit"),
            Field('dataSizeLimit','rlimit_data',"Maximum data size limit"),
            Field('rssSizeLimit','rlimit_rss',"Maximum resident size limit"),
            Field('stackLimit','rlimit_stack',"Stack size limit")
            ]
        self.objclass=['clumpXinetdService']
        self.subdirs=[]
        BaseObject.__init__(self,"xinetdsvc","clumpXinetdService","cn")

    def onSet(self,dn,data):
        return

register(XinetdService())
